local HeadCount = LibStub("AceAddon-3.0"):NewAddon("HeadCount2", "AceEvent-3.0", "AceConsole-3.0")
if not HeadCount then return end
-- Load Locales
local L = LibStub("AceLocale-3.0"):GetLocale("HeadCount2")

-- class functionality hooks

function HeadCount:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("HeadCount2DB", {}, "Default")
	self.db.RegisterCallback(self, "OnProfileChanged", "Reset")
	self.db.RegisterCallback(self, "OnProfileCopied", "Reset")
	self.db.RegisterCallback(self, "OnProfileReset", "Reset")
	self.db.RegisterCallback(self, "OnDatabaseShutdown","Serialize")
	-- Setup constants
	self:InitializeConstants()
end

function HeadCount:Serialize()
	-- Remove metadata methods from our data?
	-- Sicne AceDB-3.0 doesnt support OO like AceDB-2.0 did we need to do some magic here.
end

function HeadCount:OnEnable()
	
	local m = self.Boss:New(self.db.profile.test)
	print(m.name)
	--local b = self.Boss:New({})
	--print(b.name)
	--b.name ="TestBoss"
	--self.db.profile.test = b:Pack()
end

function HeadCount:OnDisable()
end

function HeadCount:Reset()
end
